VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRegistry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

'Version 1.00, 15.01.03
'(c) by Goetz Reinecke 01/2003
'    reinecke@activevb.de

Option Explicit

Option Compare Text

Public Event Progress(ByVal Percent As Long)

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" _
        Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal _
        lpSubKey As String, ByVal ulOptions As Long, _
        ByVal samDesired As Long, phkResult As Long) _
        As Long

Private Declare Function RegCloseKey Lib "advapi32.dll" _
        (ByVal hKey As Long) As Long
        
Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias _
        "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex _
        As Long, ByVal lpName As String, lpcbName As Long, _
        ByVal lpReserved As Long, ByVal lpClass As String, _
        lpcbClass As Long, lpftLastWriteTime As FILETIME) _
        As Long
        
Private Declare Function RegEnumValue Lib "advapi32.dll" _
        Alias "RegEnumValueA" (ByVal hKey As Long, ByVal _
        dwIndex As Long, ByVal lpValueName As String, _
        lpcbValueName As Long, lpReserved As Long, lpType _
        As Long, lpData As Any, lpcbData As Long) As Long
        
Private Declare Function RegQueryInfoKey Lib "advapi32.dll" _
        Alias "RegQueryInfoKeyA" (ByVal hKey As Long, ByVal _
        lpClass As String, lpcbClass As Long, lpReserved As Long, _
        lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, _
        lpcbMaxClassLen As Long, lpcValues As Long, _
        lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, _
        lpcbSecurityDescriptor As Long, _
        lpftLastWriteTime As FILETIME) As Long
               
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" _
        Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal _
        lpSubKey As String, ByVal Reserved As Long, ByVal _
        lpClass As String, ByVal dwOptions As Long, ByVal _
        samDesired As Long, ByVal lpSecurityAttributes As Any, _
        phkResult As Long, lpdwDisposition As Long) As Long
        
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias _
        "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As _
        String) As Long

Private Declare Function RegFlushKey Lib "advapi32.dll" (ByVal _
        hKey As Long) As Long
                               
Private Declare Function RegQueryValueEx Lib "advapi32.dll" _
        Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal _
        lpValueName As String, ByVal lpReserved As Long, _
        lpType As Long, lpData As Any, lpcbData As Any) As Long
        
Private Declare Function RegQueryValue Lib "advapi32.dll" Alias _
        "RegQueryValueA" (ByVal hKey As Long, ByVal lpSubKey As _
        String, ByVal lpValue As String, lpcbValue As Long) As _
        Long
        
Private Declare Function RegSetValueEx Lib "advapi32.dll" _
        Alias "RegSetValueExA" (ByVal hKey As Long, ByVal _
        lpValueName As String, ByVal Reserved As Long, ByVal _
        dwType As Long, lpData As Long, ByVal cbData As Long) _
        As Long
        
Private Declare Function RegSetValueEx_Str Lib "advapi32.dll" _
        Alias "RegSetValueExA" (ByVal hKey As Long, ByVal _
        lpValueName As String, ByVal Reserved As Long, ByVal _
        dwType As Long, ByVal lpData As String, ByVal cbData As _
        Long) As Long
        
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias _
        "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName _
        As String) As Long
        
Private Declare Function RegConnectRegistry Lib "advapi32.dll" _
        Alias "RegConnectRegistryA" (ByVal lpMachineName As String, _
        ByVal hKey As Long, phkResult As Long) As Long


Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const HKEY_USERS = &H80000003
Private Const HKEY_PERFORMANCE_DATA = &H80000004
Private Const HKEY_CURRENT_CONFIG = &H80000005
Private Const HKEY_DYN_DATA = &H80000006

Public Enum RegistryRootConstants
    regClassesRoot = HKEY_CLASSES_ROOT
    regCurrentConfig = HKEY_CURRENT_CONFIG
    regCurrentUser = HKEY_CURRENT_USER
    regDynData = HKEY_DYN_DATA
    regLocalMachine = HKEY_LOCAL_MACHINE
    regPerformanceData = HKEY_PERFORMANCE_DATA
    regUsers = HKEY_USERS
End Enum

Public Enum RegistryRootKeyCreateConstants
    keyClassesRoot = HKEY_CLASSES_ROOT
    keyCurrentUser = HKEY_CURRENT_USER
    keyLocalMachine = HKEY_LOCAL_MACHINE
    keyUsers = HKEY_USERS
End Enum


Private Const KEY_EVENT = &H1
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const KEY_LENGTH_MASK = &HFFFF0000

Private Const READ_CONTROL = &H20000
Private Const SYNCHRONIZE = &H100000

Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const STANDARD_RIGHTS_EXECUTE = (READ_CONTROL)
Private Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Private Const STANDARD_RIGHTS_REQUIRED = &HF0000
Private Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)

Private Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Private Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
Private Const KEY_EXECUTE = (KEY_READ)


Public Enum RegistryRightConstants
    rgtEvent = KEY_EVENT
    rgtQueryValue = KEY_QUERY_VALUE
    rgtSetValue = KEY_SET_VALUE
    rgtCreateSubKey = KEY_CREATE_SUB_KEY
    rgtEnumerateSubKeys = KEY_ENUMERATE_SUB_KEYS
    rgtNotify = KEY_NOTIFY = &H10
    rgtCreateLink = KEY_CREATE_LINK
    rgtLengthMask = KEY_LENGTH_MASK
    rgtRead = KEY_READ
    rgtExecute = KEY_READ
    rgtWrite = KEY_WRITE
    rgtAllAccess = KEY_ALL_ACCESS
End Enum

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Const ERROR_SUCCESS = 0&
Private Const ERROR_NO_MORE_ITEMS = 259&

Private Const REG_NONE = &H0                'No defined value type.
Private Const REG_SZ = &H1                  'A null-terminated string. It will be a Unicode or ANSI string depending on whether you use the Unicode or ANSI functions.
Private Const REG_EXPAND_SZ = &H2           'A null-terminated string that contains unexpanded references to environment variables (for example, "%PATH%"). It will be a Unicode or ANSI string depending on whether you use the Unicode or ANSI functions.
Private Const REG_BINARY = &H3              'Binary data in any form.
Private Const REG_DWORD = &H4               'A 32-bit number.
Private Const REG_DWORD_BIG_ENDIAN = &H5    'A 32-bit number in big-endian format. In big-endian format, the most significant byte of a word is the low-order word.
Private Const REG_LINK = &H6                'A Unicode symbolic link.
Private Const REG_MULTI_SZ = &H7            'An array of null-terminated strings, terminated by two null characters.
Private Const REG_RESOURCE_LIST = &H8       'A device-driver resource list.

Public Enum RegistryDataConstants
    datBinary = REG_BINARY
    datWord = REG_DWORD
    datBigEndian = REG_DWORD_BIG_ENDIAN
    datStringUnexpanded = REG_EXPAND_SZ
    datLink = REG_LINK
    datStringArray = REG_MULTI_SZ
    datNone = REG_NONE
    datResourceList = REG_RESOURCE_LIST
    datString = REG_SZ
End Enum

Public Enum OptionConstants
    regSorted = 1
    regUnsorted = 2
End Enum

Private Const REG_OPTION_NON_VOLATILE = &H0
Private Const REG_OPTION_VOLATILE = &H1
Private Const REG_OPTION_CREATE_LINK = &H2
Private Const REG_OPTION_BACKUP_RESTORE = &H4
Private Const REG_OPTION_OPEN_LINK = &H8

Private Const REG_CREATED_NEW_KEY = &H1
Private Const REG_OPENED_EXISTING_KEY = &H2

Private m_StandardValueName As String
Private m_StandardValueNonSetted As String
Private m_BinaryEmptyValue As String
Private m_OptionRoot As RegistryRootConstants
Private m_OptionPath As String
Private m_OptionSection As String
Private m_optPath As String

Public Function SubKeysEnum(Root As RegistryRootConstants, ByRef Path As String, ByRef strKey() As String, Optional ByRef Options As OptionConstants = regUnsorted) As Boolean
    Dim hKey As Long, Result As Long, Index As Long, fTime As FILETIME, KeyBuffer As String
    Dim KeyName As String, KeyNameLength As Long, Class As String, ClassBuffer As String
    Dim SubKeysCount As Long, SubKeysMaxNameLength As Long, Flag As Boolean

        hKey = OpenKey(Root, rgtRead, Path)
        
        If hKey <> 0 Then
            Flag = GetSubKeysInfo(hKey, SubKeysCount, SubKeysMaxNameLength)
            
            If (Flag) And (SubKeysCount > 0) Then
                ReDim strKey(0 To SubKeysCount - 1)
                
                SubKeysMaxNameLength = SubKeysMaxNameLength + 1
                ClassBuffer = Space$(255)
                KeyBuffer = Space(SubKeysMaxNameLength)
                
                Do
                    KeyNameLength = SubKeysMaxNameLength
                    KeyName = KeyBuffer
                    Class = ClassBuffer
                
                    Result = RegEnumKeyEx(hKey, Index, KeyName, KeyNameLength, 0&, Class, 255&, fTime)
                    
                    If Result = ERROR_SUCCESS Then
                        strKey(Index) = Left$(KeyName, KeyNameLength)
                        Index = Index + 1
                    End If

                Loop While (Result = ERROR_SUCCESS)
                
                SubKeysEnum = (Result = ERROR_NO_MORE_ITEMS)
                
                If (UBound(strKey) > 0) And (Options = regSorted) Then
                    Call QuickSort(strKey, 0, UBound(strKey))
                End If
                
            End If
            
            Call CloseKey(hKey)
        End If
End Function

Public Function ValuesEnum(Root As RegistryRootConstants, ByRef Path As String, ByRef strValues() As String, ByRef lngTypes() As Long, Optional ByRef Options As OptionConstants = regUnsorted) As Boolean
    Dim hKey As Long, regType As Long, Result As Long, Index As Long, Flag As Boolean
    Dim ValuesCount As Long, ValueMaxNameLength As Long, ValueMaxLength As Long
    Dim ValueName As String, ValueNameLength As Long, Standard As Boolean
        
        hKey = OpenKey(Root, rgtRead, Path)
        If hKey <> 0 Then
        
            Flag = GetValuesInfo(hKey, ValuesCount, ValueMaxNameLength, ValueMaxLength)
            
            If (Flag) And (ValuesCount > 0) Then
                ReDim strValues(0 To ValuesCount - 1)
                ReDim lngTypes(0 To ValuesCount - 1)
                ValueMaxNameLength = ValueMaxNameLength + 1
                
                Do
                    ValueNameLength = ValueMaxNameLength
                    ValueName = Space(ValueNameLength)
                                       
                    Result = RegEnumValue(hKey, Index, ValueName, ValueNameLength, _
                                          ByVal 0&, regType, ByVal 0&, ByVal 0&)
                    
                    If Result = ERROR_SUCCESS Then
                        strValues(Index) = Left(ValueName, ValueNameLength)
                        If strValues(Index) = "" Then
                            strValues(Index) = m_StandardValueName
                            Standard = True
                        End If
                        
                        lngTypes(Index) = regType
                        Index = Index + 1
                    End If
                
                Loop While (Result = ERROR_SUCCESS)
                
                If Result = ERROR_NO_MORE_ITEMS Then
                    ValuesEnum = True
                    
                    If Not Standard Then
                        ReDim Preserve strValues(0 To UBound(strValues) + 1)
                        ReDim Preserve lngTypes(0 To UBound(strValues))
                        
                        strValues(UBound(strValues)) = m_StandardValueName
                        lngTypes(UBound(strValues)) = datString
                    End If
                    
                    If (UBound(strValues) > 0) And (Options And regSorted) Then
                        Call QuickSortDouble(strValues, lngTypes, 0, UBound(strValues))
                    End If
                End If
            ElseIf Flag Then
                ReDim strValues(0)
                ReDim lngTypes(0)
                
                strValues(0) = m_StandardValueName
                lngTypes(0) = datString
                ValuesEnum = True
            End If
            
            Call CloseKey(hKey)
        End If
End Function

Private Function OpenKey(Root As RegistryRootConstants, ByRef Rights As RegistryRightConstants, ByRef Path As String) As Long
     Dim hKey As Long
        
        If RegOpenKeyEx(CLng(Root), Path, 0&, CLng(Rights), hKey) = ERROR_SUCCESS Then
            OpenKey = hKey
        End If
End Function

Private Function CloseKey(hKey As Long) As Boolean
    CloseKey = (RegCloseKey(hKey) = ERROR_SUCCESS)
End Function

Public Function SubKeyGetCount(Root As RegistryRootConstants, ByRef Path As String) As Long
    Dim hKey As Long, SubKeysCount As Long, l1, l2, l3, l4, f1 As FILETIME
    
        If RegOpenKeyEx(CLng(Root), Path, 0&, KEY_READ, hKey) = ERROR_SUCCESS Then
            If RegQueryInfoKey(hKey, vbNullString, ByVal 0&, ByVal 0&, _
                               SubKeysCount, l1, ByVal 0&, l2, l3, l4, _
                               ByVal 0&, f1) = ERROR_SUCCESS Then
                               
                SubKeyGetCount = SubKeysCount
            End If
            Call RegCloseKey(hKey)
        End If
End Function

Private Function GetSubKeysInfo(ByRef hKey As Long, ByRef SubKeysCount As Long, ByRef SubKeysMaxNameLength As Long) As Boolean
    Dim l1 As Long, l2 As Long, l3 As Long, Result As Long
    
        GetSubKeysInfo = GetKeyInfo(hKey, l1, l2, l3, SubKeysCount, SubKeysMaxNameLength)
End Function

Private Function GetValuesInfo(ByRef hKey As Long, ByRef ValuesCount As Long, ByRef ValueMaxNameLength As Long, ByRef ValueMaxLength As Long) As Boolean
    Dim l1 As Long, l2 As Long, Result As Long
    
        GetValuesInfo = GetKeyInfo(hKey, ValuesCount, ValueMaxNameLength, ValueMaxLength, l1, l2)
End Function


Private Function GetKeyInfo(ByRef hKey As Long, _
                                ByRef ValuesCount As Long, ByRef ValueMaxNameLength As Long, _
                                ByRef ValueMaxLength As Long, ByRef SubKeysCount As Long, _
                                ByRef SubKeysMaxNameLength As Long) As Boolean
                                
    Dim fTime As FILETIME, Result As Long

        GetKeyInfo = RegQueryInfoKey(hKey, vbNullString, ByVal 0&, ByVal 0&, _
                                     SubKeysCount, SubKeysMaxNameLength, ByVal 0&, _
                                     ValuesCount, ValueMaxNameLength, ValueMaxLength, _
                                     ByVal 0&, fTime)
                                 
        GetKeyInfo = (Result = ERROR_SUCCESS)
End Function

Public Function SubKeyExists(ByRef Root As RegistryRootConstants, ByRef Path As String) As Boolean
    Dim hKey As Long
    
        hKey = OpenKey(Root, rgtRead, Path)
        If hKey <> 0 Then
            SubKeyExists = True
            Call CloseKey(hKey)
        End If
End Function

Public Function SubKeyCreate(ByRef Root As RegistryRootKeyCreateConstants, ByRef Path As String, Optional ByRef Flush As Boolean = False) As Boolean
    Dim Result As Long, hKey As Long, Back As Long
    
        Result = RegCreateKeyEx(Root, Path, 0&, vbNullString, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 0&, hKey, Back)
    
        If Result = ERROR_SUCCESS Then
            If Flush Then Result = RegFlushKey(hKey)
            If Result = ERROR_SUCCESS Then
                SubKeyCreate = True
                Call CloseKey(hKey)
            End If
        End If
End Function

Public Function SubKeyDelete(ByRef Root As RegistryRootKeyCreateConstants, ByRef Path As String) As Boolean
    SubKeyDelete = (RegDeleteKey(CLng(Root), Path) = ERROR_SUCCESS)
End Function

Private Function SubKeyEnumRecurse(ByRef Root As RegistryRootConstants, ByVal Path As String, ByRef strKey() As String) As Boolean
    Dim Result As Long, SubKeysCount As Long, SubKeysMaxNameLength As Long, fTime As FILETIME, Index As Long
    Dim Class As String, ClassBuffer As String, KeyBuffer As String, KeyName As String, KeyNameLength As Long
    Dim hKey As Long, Flag As Boolean, NewPath As String
    
        hKey = OpenKey(Root, rgtRead, Path)
        
        If hKey <> 0 Then
        
            Flag = GetSubKeysInfo(hKey, SubKeysCount, SubKeysMaxNameLength)
            If (Flag) And (SubKeysCount > 0) Then
                                        
                ClassBuffer = Space$(255)
                KeyBuffer = Space(SubKeysMaxNameLength)
                
                Do
                    KeyNameLength = SubKeysMaxNameLength
                    KeyName = KeyBuffer
                    Class = ClassBuffer
                
                    Result = RegEnumKeyEx(hKey, Index, KeyName, KeyNameLength, 0&, Class, 255&, fTime)
                        
                    If Result = ERROR_SUCCESS Then
                        
                        If Path <> "" Then
                            strKey(UBound(strKey)) = Path & "\" & Left$(KeyName, KeyNameLength)
                        Else
                            strKey(UBound(strKey)) = Left$(KeyName, KeyNameLength)
                        End If
                        
                        ReDim Preserve strKey(0 To UBound(strKey) + 1)
                        
                        Call SubKeyEnumRecurse(Root, strKey(UBound(strKey) - 1), strKey)
                        Index = Index + 1
                    End If
                        
                Loop While (Result = ERROR_SUCCESS)
            End If
            Call CloseKey(hKey)
        End If
End Function

Public Function SubKeyCopy(ByRef SrcRoot As RegistryRootConstants, ByVal SrcPath As String, _
                           ByRef DstRoot As RegistryRootConstants, ByVal DstPath As String, _
                           Optional ByRef ShowProgress As Boolean = True) As Boolean
                           
    Dim Field() As String, x As Long, Flag As Boolean, Max As Long, DivValue As Single, ProgValue As Single
    Dim Percent As Long, NewPath As String
    
        If InStr(SrcPath, DstPath) = 0 Then
            ReDim Field(1)
            Field(0) = SrcPath
            
            Call SubKeyEnumRecurse(SrcRoot, SrcPath, Field)
        
            Max = UBound(Field)
            DivValue = Max / 100
            ProgValue = DivValue
            
            For x = 0 To Max - 1
                
                NewPath = Mid$(Field(x), Len(SrcPath) + 2)
                If NewPath = "" Then
                    NewPath = DstPath
                Else
                    NewPath = DstPath & "\" & NewPath
                End If
                
                Flag = SubKeyCreate(DstRoot, NewPath)
                If Not Flag Then Exit For
                
                Flag = SubKeyCopyValues(SrcRoot, Field(x), DstRoot, NewPath)
                If Not Flag Then Exit For
                
                If ShowProgress Then
                    If x >= ProgValue Then
                        Percent = x / Max * 100
                        If Percent > 100 Then Percent = 100
                        RaiseEvent Progress(Percent)
                        ProgValue = ProgValue + DivValue
                    End If
                End If
            Next x
            
            If Flag Then RaiseEvent Progress(100)
            
            SubKeyCopy = Flag
        End If
End Function

Private Function SubKeyCopyValues(ByRef SrcRoot As RegistryRootConstants, ByVal SrcPath As String, _
                                  ByRef DstRoot As RegistryRootConstants, ByVal DstPath As String) As Boolean
    
    Dim hKeySrc As Long, hKeyDst As Long, Flag As Boolean, Result As Long, Index As Long
    Dim ValuesCount As Long, ValueMaxNameLength As Long, ValueMaxLength As Long
    Dim ValueName As String, ValueNameLength As Long, regType As Long, hKey As Long
    Dim strBuffer As String, DataLength As Long
    
        hKeySrc = OpenKey(SrcRoot, rgtRead, SrcPath)
        If hKeySrc <> 0 Then
            
            hKeyDst = OpenKey(DstRoot, rgtWrite, DstPath)
            If hKeyDst <> 0 Then
                Flag = GetValuesInfo(hKeySrc, ValuesCount, ValueMaxNameLength, ValueMaxLength)
                If Flag And (ValuesCount > 0) Then
                
                    ValueMaxNameLength = ValueMaxNameLength + 1
                    
                    Do
                        ValueNameLength = ValueMaxNameLength
                        ValueName = Space(ValueNameLength)
                    
                        Result = RegEnumValue(hKeySrc, Index, ValueName, ValueNameLength, _
                                              ByVal 0&, regType, ByVal 0&, ByVal 0&)
                        
                        If Result = ERROR_SUCCESS Then
                            ValueName = Left(ValueName, ValueNameLength)

                            DataLength = ValueMaxLength + 1
                            strBuffer = Space$(DataLength)
                    
                            Result = RegQueryValueEx(hKeySrc, ValueName, 0&, regType, ByVal strBuffer, DataLength)
                            If Result = ERROR_SUCCESS Then
                                Result = RegSetValueEx_Str(hKeyDst, ValueName, 0&, regType, strBuffer, DataLength)
                                Index = Index + 1
                            End If
                        End If
                        
                    Loop While (Result = ERROR_SUCCESS)
                    
                    If Result = ERROR_NO_MORE_ITEMS Then SubKeyCopyValues = True
                ElseIf Flag And (ValuesCount = 0) Then
                    SubKeyCopyValues = True
                End If
                CloseKey (hKeyDst)
            End If
            CloseKey (hKeySrc)
        End If
End Function


Public Function ValueExists(ByRef Root As RegistryRootConstants, ByRef Path As String, ByRef ValueName As String) As Boolean
    Dim dwType As Long, DataLength As Long, hKey As Long
    
        hKey = OpenKey(Root, rgtRead, Path)
        If hKey <> 0 Then
            ValueExists = (RegQueryValueEx(hKey, ValueName, 0&, dwType, ByVal 0&, DataLength) = 0)
            Call CloseKey(hKey)
        End If
End Function

Public Function ValueWrite(ByRef Root As RegistryRootConstants, ByRef Path As String, ByRef ValueName As String, ByRef Value As Variant, Optional ByRef Flush = False) As Boolean
    Dim Result As Long, hKey As Long, strV As String, lngV As Long, x As Long

        hKey = OpenKey(Root, rgtWrite, Path)
    
        If hKey <> 0 Then
            Select Case VarType(Value)
                Case vbString:                  strV = CStr(Value) & Chr$(0)
                                                Result = RegSetValueEx_Str(hKey, ValueName, 0&, REG_SZ, strV, Len(strV))
                                                
                                                
                Case vbInteger, vbLong, vbByte: lngV = CLng(Value)
                                                Result = RegSetValueEx(hKey, ValueName, 0&, REG_DWORD, lngV, 4&)
                                                
                                                
                Case vbSingle, vbDouble:        strV = CStr(Value)
                                                Result = RegSetValueEx_Str(hKey, ValueName, 0&, REG_SZ, strV, Len(strV) + 1)
                
                
                Case vbBoolean:                 lngV = CLng(Value)
                                                Result = RegSetValueEx(hKey, ValueName, 0&, REG_DWORD, lngV, 4&)
                                                                
                                                                
                Case (vbArray Or vbByte):
                                                If ArrayHasValues(Value) Then
                                                    For x = LBound(Value) To UBound(Value)
                                                        strV = strV & Chr$(Value(x))
                                                    Next x
                                                End If
                                                Result = RegSetValueEx_Str(hKey, ValueName, 0&, REG_BINARY, strV, Len(strV))
                
                
                Case Else:                      Result = 1
                
            End Select
        
            If Result = ERROR_SUCCESS Then ValueWrite = True
            
            Call CloseKey(hKey)
        End If
        
End Function

Public Function ValueCopy(ByRef SrcRoot As RegistryRootConstants, ByVal SrcPath As String, ByRef SrcValueName As String, _
                           ByRef DstRoot As RegistryRootConstants, ByVal DstPath As String, ByRef DstValueName As String, _
                           Optional ByRef ShowProgress As Boolean = True) As Boolean
                           
    Dim hKeySrc As Long, hKeyDst As Long, Result As Long, regType As Long, strBuffer As String, DataLength As Long
    
        hKeySrc = OpenKey(SrcRoot, rgtRead, SrcPath)
        If hKeySrc <> 0 Then
            DataLength = 512
            strBuffer = Space$(DataLength)
            
            Result = RegQueryValueEx(hKeySrc, SrcValueName, 0&, regType, ByVal strBuffer, DataLength)
            Call CloseKey(hKeySrc)
            
            If Result = ERROR_SUCCESS Then
                hKeyDst = OpenKey(DstRoot, rgtWrite, DstPath)
                
                If hKeyDst <> 0 Then
                    ValueCopy = (RegSetValueEx_Str(hKeyDst, DstValueName, 0&, regType, strBuffer, DataLength) = ERROR_SUCCESS)
                End If
                Call CloseKey(hKeyDst)
            End If
        End If
End Function

Public Function ValueRead(ByRef Root As RegistryRootConstants, ByRef Path As String, ByVal ValueName As String, ByRef Value As Variant, Optional ByRef regDataType As RegistryDataConstants) As Boolean
    Dim Result As Long, hKey As Long, regType As Long, lngBuffer As Long, strBuffer As String, DataLength As Long
  
        hKey = OpenKey(Root, rgtRead, Path)
        
        If hKey <> 0 Then
            
            DataLength = 512
            strBuffer = Space$(DataLength)
            
            If ValueName = m_StandardValueName Or ValueName = "" Then

                Result = RegQueryValue(hKey, vbNullString, ByVal strBuffer, DataLength)
                Value = Left$(strBuffer, DataLength - 1)
                regDataType = datString
            Else
                Result = RegQueryValueEx(hKey, ValueName, 0&, regType, ByVal 0&, DataLength)
                
                If Result = ERROR_SUCCESS Then
                    Select Case regType
                    
                        Case REG_SZ:                Result = RegQueryValueEx(hKey, ValueName, 0&, regType, ByVal strBuffer, DataLength)
                                                    If Result = ERROR_SUCCESS Then Value = Left$(strBuffer, DataLength - 1)
                                    
                        Case REG_DWORD:             Result = RegQueryValueEx(hKey, ValueName, 0&, regType, lngBuffer, DataLength)
                                                    If Result = ERROR_SUCCESS Then Value = lngBuffer
                                           
                        Case REG_BINARY:            Result = RegQueryValueEx(hKey, ValueName, 0&, regType, ByVal strBuffer, DataLength)
                                                    If Result = ERROR_SUCCESS Then Value = Left$(strBuffer, DataLength)
                        
                        Case REG_EXPAND_SZ:         Result = RegQueryValueEx(hKey, ValueName, 0&, regType, ByVal strBuffer, DataLength)
                                                    If Result = ERROR_SUCCESS Then Value = Left$(strBuffer, DataLength - 1)
                                            
                        Case REG_DWORD_BIG_ENDIAN:  Result = RegQueryValueEx(hKey, ValueName, 0&, regType, lngBuffer, DataLength)
                                                    If Result = ERROR_SUCCESS Then Value = lngBuffer
                        
                    End Select
                    
                    regDataType = regType
                End If
            End If
            
            If Result = ERROR_SUCCESS Then ValueRead = True
            Call CloseKey(hKey)
        End If
    
End Function

Public Function ValueDelete(ByRef Root As RegistryRootConstants, ByRef Path As String, ByRef ValueName As String) As Boolean
    Dim Result As Long, hKey As Long
        
        hKey = OpenKey(Root, rgtAllAccess, Path)
        If hKey <> 0 Then
            ValueDelete = (RegDeleteValue(hKey, ValueName) = ERROR_SUCCESS)
            Call CloseKey(hKey)
        End If
End Function

Public Function ValuesDeleteByList(ByRef Root As RegistryRootConstants, ByRef Path As String, strValueNames() As String, ByRef lngLBound As Long, ByRef lngUBound As Long) As Boolean
    Dim x As Long, L As Long, u As Long, hKey As Long, Result As Long, Flag As Boolean
         
        L = LBound(strValueNames)
        u = UBound(strValueNames)
        
        If (lngUBound <= u And lngUBound >= L) And (lngLBound <= u And lngLBound >= L) Then
            If (lngLBound <= lngUBound) Then
                hKey = OpenKey(Root, rgtWrite, Path)
                If hKey <> 0 Then
                    Flag = True
                    For x = lngLBound To lngUBound
                        If (RegDeleteValue(hKey, strValueNames(x)) <> ERROR_SUCCESS) Then Flag = False
                    Next x
                    
                    Call CloseKey(hKey)
                    ValuesDeleteByList = Flag
                End If
            End If
        End If
                    
End Function

Public Function GetRemoteKey(ByRef RemoteName As String, ByRef Root As RegistryRootConstants) As Long
    Dim Result As Long, hKey As Long
    
        Result = RegConnectRegistry("\\" & RemoteName, Root, hKey)
    
        If Result = ERROR_SUCCESS Then
            GetRemoteKey = hKey
            'Call CloseKey(hKey)
        End If
End Function

Private Sub QuickSort(ByRef Field() As String, ByVal LB As Long, ByVal UB As Long)
    Dim P1 As Long, P2 As Long, Ref As String, TEMP As String
    
        P1 = LB
        P2 = UB
        Ref = Field((P1 + P2) / 2)
      
        Do
            Do While (Field(P1) < Ref)
                P1 = P1 + 1
            Loop
    
            Do While (Field(P2) > Ref)
                P2 = P2 - 1
            Loop
    
            If P1 <= P2 Then
                TEMP = Field(P1)
                Field(P1) = Field(P2)
                Field(P2) = TEMP
              
                P1 = P1 + 1
                P2 = P2 - 1
            End If
        Loop Until (P1 > P2)
    
        If LB < P2 Then Call QuickSort(Field, LB, P2)
        If P1 < UB Then Call QuickSort(Field, P1, UB)
End Sub

Private Sub QuickSortDouble(ByRef Field1() As String, ByRef Field2() As Long, ByVal LB As Long, ByVal UB As Long)
    Dim P1 As Long, P2 As Long, Ref As String, TEMP1 As String, TEMP2 As Long
    
        P1 = LB
        P2 = UB
        Ref = Field1((P1 + P2) / 2)
      
        Do
            Do While (Field1(P1) < Ref)
                P1 = P1 + 1
            Loop
    
            Do While (Field1(P2) > Ref)
                P2 = P2 - 1
            Loop
    
            If P1 <= P2 Then
                TEMP1 = Field1(P1)
                Field1(P1) = Field1(P2)
                Field1(P2) = TEMP1
              
                TEMP2 = Field2(P1)
                Field2(P1) = Field2(P2)
                Field2(P2) = TEMP2
                
                P1 = P1 + 1
                P2 = P2 - 1
            End If
        Loop Until (P1 > P2)
    
        If LB < P2 Then Call QuickSortDouble(Field1, Field2, LB, P2)
        If P1 < UB Then Call QuickSortDouble(Field1, Field2, P1, UB)
End Sub

Public Function GetHexString(ByRef Value As Variant) As String
    Dim H As String, z As Double, V As Long
    
        V = CLng(Value)
        If Value < 0 Then
            z = V + 2147483648# + 2147483648#
        Else
            z = V
        End If
        
        H = LCase(Hex(V))
        H = "0x" & String$(8 - Len(H), "0") & H & " (" & CStr(z) & ")"
        GetHexString = H
End Function

Public Function GetBinaryString(ByRef Value As Variant) As String
    Dim Length As Long, x As Long, c As String, z As Long, b As String, H As String, V As String
    
        V = CStr(Value)
        Length = Len(V)
        If Length > 0 Then
            For x = 1 To Length
                c = Mid$(V, x, 1)
                If c = "" Then
                    z = 0
                Else
                    z = Asc(c)
                End If
                
                H = LCase(Hex(z))
                b = b & String$(2 - Len(H), "0") & H & " "
            Next x
            GetBinaryString = Trim$(b)
        Else
            GetBinaryString = m_BinaryEmptyValue
        End If
End Function

Public Function GetStringString(ByRef Value As Variant, ByRef ValueName) As String
    Dim s As String
    
        s = CStr(Value)
        If s <> "" Then
            GetStringString = Chr$(34) & CStr(Value) & Chr$(34)
        Else
            If ValueName = "" Or ValueName = m_StandardValueName Then
                GetStringString = m_StandardValueNonSetted
            Else
                GetStringString = Chr$(34) & Chr$(34)
            End If
        End If
End Function

Public Function GetStringDataType(ByRef DataType As RegistryDataConstants) As String
    Dim Result As String
    
        Select Case DataType
            Case datString:             Result = "REG_SZ"
            Case datWord:               Result = "REG_DWORD"
            Case datBinary:             Result = "REG_BINARY"
            Case datStringUnexpanded:   Result = "REG_EXPAND_SZ"
            Case datBigEndian:          Result = "REG_DWORD_BIG_ENDIAN"
            Case datLink:               Result = "REG_LINK"
            Case datStringArray:        Result = "REG_MULTI_SZ"
            Case datNone:               Result = "REG_NONE"
            Case datResourceList:       Result = "REG_RESOURCE_LIST"
        End Select
        
        GetStringDataType = Result
End Function

Public Function GetStringRoot(ByRef DataType As RegistryRootConstants) As String
    Dim Result As String
    
        Select Case DataType
            Case regClassesRoot:        Result = "HKEY_CLASSES_ROOT"
            Case regCurrentConfig:      Result = "HKEY_CURRENT_CONFIG"
            Case regCurrentUser:        Result = "HKEY_CURRENT_USER"
            Case regDynData:            Result = "HKEY_DYN_DATA"
            Case regLocalMachine:       Result = "HKEY_LOCAL_MACHINE"
            Case regPerformanceData:    Result = "HKEY_PERFORMANCE_DATA"
            Case regUsers:              Result = "HKEY_USERS"
        End Select
        
        GetStringRoot = Result
End Function

Private Function ArrayHasValues(ByRef bArray As Variant) As Boolean
    On Error GoTo Err
    
    Dim u As Long
    
        u = UBound(bArray)
        ArrayHasValues = True
Err:
End Function

Private Sub MakeOptionsPath()
    Dim Path As String
    
        Path = m_OptionPath
        If Path <> "" Then
            If OptionSection <> "" Then Path = Path & "\" & m_OptionSection
        Else
            Path = m_OptionSection
        End If
        
        m_optPath = Path
End Sub

Private Sub Class_Initialize()
    m_StandardValueName = "(Standard)"
    m_StandardValueNonSetted = "(Wert nicht gesetzt)"
    m_BinaryEmptyValue = "(Binrwert der Lnge Null)"
    m_OptionRoot = regCurrentUser
    m_OptionPath = "Software\VB and VBA Program Settings\" & App.Title
    m_OptionSection = "Main"
    
    Call MakeOptionsPath
End Sub

Public Property Let StandardValueName(stdName As String)
    m_StandardValueName = stdName
End Property

Public Property Get StandardValueName() As String
    StandardValueName = m_StandardValueName
End Property

Public Property Let StandardValueNonSetted(stdNonSetted As String)
    m_StandardValueNonSetted = stdNonSetted
End Property

Public Property Get StandardValueNonSetted() As String
    StandardValueNonSetted = m_StandardValueNonSetted
End Property

Public Property Let BinaryEmptyValue(stdBinaryEmptyValue As String)
    m_BinaryEmptyValue = stdBinaryEmptyValue
End Property

Public Property Get BinaryEmptyValue() As String
    BinaryEmptyValue = m_BinaryEmptyValue
End Property

Public Property Let OptionRoot(n_OptionRoot As RegistryRootConstants)
    m_OptionRoot = n_OptionRoot
End Property

Public Property Get OptionRoot() As RegistryRootConstants
    OptionRoot = m_OptionRoot
End Property

Public Property Let OptionPath(n_OptionPath As String)
    m_OptionPath = n_OptionPath
    Call MakeOptionsPath
End Property

Public Property Get OptionPath() As String
    OptionPath = m_OptionPath
End Property

Public Property Let OptionSection(n_OptionSection As String)
    m_OptionSection = n_OptionSection
    Call MakeOptionsPath
End Property

Public Property Get OptionSection() As String
    OptionSection = m_OptionSection
End Property

Public Function OptionSave(ByRef ValueName As String, ByRef Value As Variant) As Boolean
    Dim Flag As Boolean
        
        Flag = SubKeyExists(m_OptionRoot, m_optPath)
        If Not Flag Then Flag = SubKeyCreate(m_OptionRoot, m_optPath)

        If Flag Then
            OptionSave = ValueWrite(m_OptionRoot, m_optPath, ValueName, Value)
        End If
End Function

Public Function OptionLoad(ByRef ValueName As String, Optional ByRef Default As Variant = 0) As Variant
    Dim Value As Variant
        
        Value = Default
        If SubKeyExists(m_OptionRoot, m_optPath) Then
            If ValueExists(m_OptionRoot, m_optPath, ValueName) Then
                If Not ValueRead(m_OptionRoot, m_optPath, ValueName, Value) Then Value = Default
            End If
        End If
        
        OptionLoad = Value
End Function
